'''combines a directory of text files together'''
import os
import glob
import random
from argparse import ArgumentParser

p = ArgumentParser()
p.add_argument("--directory", "-i", default="good",
               help="directory of text files to combine")
p.add_argument("--output", "-o", default="anime-transcripts.train.txt",
               help="training set filename")
p.add_argument("--validation-set", "-v",
               help="validation set filename")
p.add_argument("--test-set", "-t",
               help="test set filename")
p.add_argument("--delimiter", "-d", default="<|endoftext|>",
               help="text delimiter")
p.add_argument("--seed", "-s", default=4423,
               help="random seed")
p.add_argument("--shuffle", action="store_true",
               help="shuffle order of transcripts")
p.add_argument("--slice", type=float, default=0.98)
args = p.parse_args()

files = glob.glob(os.path.join(args.directory, "*.txt"))
random.seed(args.seed)
print(args)
if args.test_set:
    count = len(files)
    split = int(count * args.slice)
    f = open(args.test_set, "w")
    files2 = files[split:]
    if args.shuffle: random.shuffle(files2)
    for filename in files2:
        f.write(open(filename).read().strip() + "\n" + args.delimiter + "\n")
    files = files[:split]

if args.validation_set:
    count = len(files)
    split = int(count * args.slice)
    f = open(args.validation_set, "w")
    files2 = files[split:]
    if args.shuffle: random.shuffle(files2)
    for filename in files2:
        f.write(open(filename).read().strip() + "\n" + args.delimiter + "\n")
    files = files[:split]

if args.shuffle: random.shuffle(files)
f = open(args.output, "w")
for filename in files:
    f.write(open(filename).read().strip() + "\n" + args.delimiter + "\n")
